/**
 * @file
 * Datalist clear button handling.
 */
(function () {
  'use strict';

  /**
   * Drupal behavior.
   */
  Drupal.behaviors.datalist = {
    attach: function (context) {
      const datalistsClear = document.querySelectorAll('.form-type-datalist .clear');
      const datalistsInput = document.querySelectorAll('.form-type--datalist input');
      if (datalistsClear.length === 0) {
        return;
      }

      datalistsInput.forEach(dataListInput => {
        dataListInput.addEventListener('input', function(e) {
          const value = e.target.value;
          if (!value || value === '') {
            e.currentTarget.parentElement.querySelector('.clear').classList.add('not-visible');
          } else {
            if (!e.currentTarget.parentElement.querySelector('.clear').classList.contains('visible')) {
              e.currentTarget.parentElement.querySelector('.clear').classList.add('visible');
              e.currentTarget.parentElement.querySelector('.clear').classList.remove('not-visible');
            }
          }
        });
      });

      datalistsClear.forEach(datalistClear => {
        datalistClear.addEventListener('click', function (e) {
          e.preventDefault();

          e.currentTarget.parentElement.querySelector('input').value = '';
          e.currentTarget.classList.remove('visible');
          e.currentTarget.classList.add('not-visible');
        });
      })
    },
  };

})();
